// -------------------------
// Skiing Events!

// By Axolotl
// BL_ID 32440

// I'm also using a new coding syntax
// -------------------------


// Part 1: Force-enable skis
// This part is automatically done on server.cs


// ----------
// Part 2: Output events
// Don't get your events mixed up.

registerOutputEvent( Player , startSkiing);
registerOutputEvent( Player , stopSkiing);


// ----------
// Part 3: Anti-Break / isSkiing variable

// A variable is set to NULL when it is created.
// We want this to not break VCE, so we set it to 0

package SkiEvents_AntiBreak
{    	
	function GameConnection::onClientEnterGame( %client )
	{
		parent::onClientEnterGame( %client );
		%client.player.schedule( 500 , resetSkiVar ); // We don't want to deadlock
	}
};


function resetSkiVar( %player ){ %player.isSkiing = 0; } // I don't think you can set a variable directly in a schedule

// isSkiing isn't a default variable.

package SkiEvents_IsSkiing
{    	
	function player::startSkiing( %player )
	{
		parent::startSkiing( %player );
		%player.isSkiing = 1;
	}

	function player::stopSkiing( %player )
	{
		parent::stopSkiing( %player );
		if( %player.isSkiing ){ %player.dismount(); } // anti-glitch for ZoneEvents
		%player.isSkiing = 0;
	}
};


// ----------
// Part 4: VCE interaction

package SkiEvents_InitVars
{
	function VCE_initServer()
	{
		Parent::VCE_initServer();
		registerSpecialVar(Player,"isSkiing","%this.isSkiing");
	}
};


// ----------
// Part 5: Activate packages

activatePackage(SkiEvents_AntiBreak);
activatePackage(SkiEvents_IsSkiing);
activatePackage(SkiEvents_InitVars);


